/*********************************************************
UZI (Unix Z80 Implementation) Sharp MZ-800 boot:  mzboot.c
**********************************************************/

/* This constant has to be synchronized with the main module */
#define MAIN_BEGIN 7000h;

/**
 * Entry point for the program. Here the tables are initialized
 * and the main module is moved at the proper place.
 */
void main() {

#asm
	di
	out	(0e0h), a		; disable ROMs, we'll be using full 64k RAM
	out	(0e1h), a
	in	a, (0e1h)
	ld	sp, 10f0h
#endasm

  mz_init_video();

#asm
	ld	hl, (10f0h + 24)	; get the beginning of the next module
	ld	de, (10f0h + 20)	; get the MZF beginning
	or	a
	sbc	hl, de			; we have the size of the boot block
	ex	de, hl
	ld	hl, (10f0h + 18)	; get the MZF size
	sbc	hl, de			; we have the size of the main block now
	ld	b, h
	ld	c, l

	ex	de, hl
	ld	hl, MAIN_BEGIN
	add	hl, de
	dec	hl			;  we have the endpoint of destination position of the main block
	push	hl

	ld	hl, (10f0h + 20)	; get the MZF beginning - 1
	dec	hl
	ld	de, (10f0h + 18)	; get the MZF size
	add	hl, de			; go at the end - 1
	pop	de

	lddr				; move the main block at the proper position
	ld	sp, MAIN_BEGIN
	ld	hl, (10f0h + 26)	; get the exec of the next module
	jp	(hl)			; start the main block
#endasm
}
