/**************************************************
UZI (Unix Z80 Implementation) Kernel:  extern.h
***************************************************/


/* These are the global data structures */

#ifdef MAIN
#define extern  
#endif


extern struct u_data udata; /* MUST BE FIRST */
extern struct p_tab ptab[PTABSIZE];

extern inoptr root;   /* Address of root dir in inode table */
extern int16 ROOTDEV;  /* Device number of root filesystem. */

extern struct cinode i_tab[ITABSIZE];    /* In-core inode table */
extern struct oft of_tab[OFTSIZE]; /* Open File Table */

extern struct filesys fs_tab[NDEVS];  /* Table entry for each
                                        device with a filesystem. */
extern struct blkbuf bufpool[NBUFS];

extern ptptr initproc; /* The process table address of the first process. */
extern int16 inint;   /* flag is set whenever interrupts are being serviced */

extern int16 sec;   /* Tick counter for counting off one second */
extern int16 runticks;  /* Number of ticks current process has been
                         swapped in */

extern time_t tod;      /* Time of day */
extern time_t ticks;    /* Cumulative tick counter, in minutes and ticks  */

extern char *swapbase;          /* Used by device driver for swapping */
extern unsigned swapcnt;
extern blkno_t swapblk;

/* external method references */
extern void bcopy( char *src, char *dest, int count );
extern char *itoa( int value, char *strP, int radix );
extern int d_open( int dev );
extern int remq( struct s_queue *q, char *cp );
extern int uninsq( struct s_queue *q, char *cp );
extern int insq( struct s_queue *q, char c );
extern int tty_int();
extern int clk_int();
extern int fmount( int dev, inoptr ino );
extern int validdev( int dev );
extern int valadr( char *base, uint16 size );
extern int getperm( inoptr ino );
extern int dofork();
extern int super();
extern int uf_alloc();
extern int oft_alloc();
extern int getmode(inoptr ino);
extern int isdevice(inoptr ino);
extern int ch_link(inoptr wd,char *oldname,char *newname,inoptr nindex);
extern int d_ioctl(int dev,int request,char *data);
extern int cdread(int dev);
extern int cdwrite(int dev);
extern int mz_is_clock_elapsed();
extern char mz_get_keystroke();

#ifdef MAIN
#undef extern
#endif

extern int unix();
