#include <stdio.h>
#include <stdlib.h>

#define BUFFER_SIZE 65536

int main( int argc, char **argv ) {
  FILE *rfile;
  FILE *wfile;
  int size;
  unsigned char read_buffer[ BUFFER_SIZE ];

  if( argc < 3 ) {
    fprintf( stderr, "Strips trailing end of file marks from the file\n" );
    fprintf( stderr, " Syntax: %s <file_to_strip> <output_file>\n" );
    return( 0 );
  }
  
  if( ( rfile = fopen( argv[ 1 ], "r" ) ) == NULL ) {
    fprintf( stderr, "Error reading the file.\n" );
    return( 0 );
  }
  if( ( wfile = fopen( argv[ 2 ], "w+" ) ) == NULL ) {
    fprintf( stderr, "Error writing the file.\n" );
    return( 0 );
  }
  
  while( ! feof( rfile ) ) {
    size = fread( &read_buffer, 1, BUFFER_SIZE, rfile );
    if( feof( rfile ) || size < BUFFER_SIZE ) {
      while( size > 0 && read_buffer[ size - 1 ] == 0x1a )
        size--;
    }
    if( size > 0 ) {
      fwrite( &read_buffer, 1, size, wfile );
    }
  }
  
  fclose( wfile );
  fclose( rfile );
}
